/*
 *   The structures and include files used in BlitLab.
 */
#define BANNER "BlitLab 1.1, Copyright (C) 1987, Radical Eye Software"
#include "exec/exec.h"
#include "intuition/intuition.h"
#include "functions.h"
#include "graphics/display.h"
#include "graphics/gfx.h"
#include "graphics/gfxmacros.h"
#include "graphics/gfxbase.h"
#include "stdio.h"
/*
 *   This is the blitter register structure we use.
 */
struct blitregs {
   short con0, con1, size, afwm, alwm ;
   short pth[4] ;
   short ptl[4] ;
   short mod[4] ;
   short dat[4] ;
} ;
/*
 *   Here we number the gadgets.
 */
#define GDGPNTREG (0)
#define GDGCLRSET (1)
#define GDGGO (2)
#define GDGSX (3)
#define GDGSY (4)
#define GDGEX (5)
#define GDGEY (6)
#define GDGLINE (7)
#define GDGH (8)
#define GDGV (9)
#define GDGDESC (10)
#define GDGFCI (11)
#define GDGIFE (12)
#define GDGEFE (13)
#define GDGSETUP (14)
#define GDGFUNC (15)
#define GDGUSEA (16)
#define GDGUSEB (17)
#define GDGUSEC (18)
#define GDGUSED (19)
#define GDGAPT (20)
#define GDGBPT (21)
#define GDGCPT (22)
#define GDGDPT (23)
#define GDGAMOD (24)
#define GDGBMOD (25)
#define GDGCMOD (26)
#define GDGDMOD (27)
#define GDGADAT (28)
#define GDGBDAT (29)
#define GDGCDAT (30)
#define GDGASH (31)
#define GDGBSH (32)
#define GDGAFWM (33)
#define GDGALWM (34)
#define GDGCALC (35)
#define MAXGADG (36)
/*
 *   These defines set the size of the screen and various subareas of
 *   the screen, including most gadget locations.
 */
#define HWINSTART (0)
#define VWINSTART (5)
#define HWINSIZE (640)
#define VWINSIZE (195)
#define HBITSTART (4)
#define VBITSTART (11)
#define HBITSIZE (96 * 6)
#define VBITSIZE (32 * 3 + 1)
#define HLMGSTART (HBITSIZE + HBITSTART + 2)
#define HLMGSIZE (HWINSIZE - HLMGSTART - 4)
#define VLMGSIZE (12)
#define VLMGINT (4)
#define VLMG1 (VBITSTART + VLMGINT)
#define VLMG2 (VLMG1 + VLMGSIZE + VLMGINT)
#define VLMG3 (VLMG2 + VLMGSIZE + VLMGINT)
#define VLMG4 (VLMG3 + VLMGSIZE + VLMGINT)
#define VLMG5 (VLMG4 + VLMGSIZE + VLMGINT)
#define VGOSTART (VLMG5 + VLMGSIZE + VLMGINT)
#define HGOSTART (HLMGSTART + 2)
#define HGOSIZE (HLMGSIZE - 4)
#define VGOSIZE (VRVSTART - VGOSTART - VLMGINT)
#define VSTRSIZE (11)
#define HSTRSIZE(a) (8 * (a) + 4)
#define HMGSIZE (63)
#define VMGSIZE (11)
#define HMGINT (1)
#define VMGINT (0)
#define HMG1START (HBITSTART)
#define HMG2START (HMG1START + HMGSIZE + HMGINT)
#define HMG3START (HMG2START + HMGSIZE + HMGINT)
#define HMG4START (HMG3START + HMGSIZE + HMGINT)
#define HMG5START (HMG4START + HMGSIZE + HMGINT)
#define HMG6START (HMG5START + HMGSIZE + HMGINT)
#define HMG7START (HMG6START + HMGSIZE + HMGINT)
#define HMG8START (HMG7START + HMGSIZE + HMGINT)
#define HMG9START (HMG8START + HMGSIZE + HMGINT)
#define VMG1START (VBITSTART + VBITSIZE)
#define VMG2START (VMG1START + VMGSIZE + VMGINT)
#define VRVSTART (VMG2START + VMGSIZE)
#define VRVL1 (VRVSTART + 2)
#define VRVL2 (VRVL1 + 9)
#define VRVL3 (VRVL2 + 9)
#define VRVL4 (VRVL3 + 9)
#define VRVL5 (VRVL4 + 9)
#define VRVL6 (VRVL5 + 9)
#define VRVLL2 (VRVL1 + 10)
#define VRVLL3 (VRVLL2 + 11)
#define VRVLL4 (VRVLL3 + 11)
#define VRVLL5 (VRVLL4 + 11)
#define VRVLL6 (VRVLL5 + 11)
#define VRG1 (VRVL1 + 8)
#define VRVSIZE (VWINSIZE - VRVSTART)
#define HRVSIZE (HWINSIZE - HBITSTART - 3)
#define HRVSTART (HBITSTART)
#define HRVC1 (HRVSTART + 6)
#define HRVC2 (HRVC1 + 5 * 8)
#define HRVC3 (HRVC2 + 5 * 8)
#define HRVC4 (HRVC3 + 2 * 8)
#define HRVC5 (HRVC4 + 5 * 8)
#define HRVC6 (HRVC5 + 5 * 8)
#define HRVC6B (HRVC6 + 5 * 8)
#define HMVSTART (HRVC6B + 35)
#define HRVC7 (HRVC6B + 5 * 8)
#define HRVC8 (HRVC7 + 2 * 8)
#define HRVC9 (HRVC8 + 3 * 8 + 4)
#define HRVC10 (HRVC9 + 9 * 8)
#define HRVC11 (HRVC10 + 7 * 8)
#define HRVC12 (HRVC11 + 19 * 8)
#define VTEXTOFF (2)
#define HTEXTOFF (2)
/*
 *   Colors.
 */
#define BLUE (0)
#define WHITE (1)
#define BLACK (2)
#define ORANGE (3)

